﻿using System;
using System.Collections.Generic;
using System.Text;

namespace RowShamBow
{
    public abstract class Player : MarshalByRefObject, IPlayer
    {
        /// <summary>
        /// 上一局我方出什么
        /// </summary>
        public Hand MyLast { get; private set; }

        /// <summary>
        /// 上一局对方出什么
        /// </summary>
        public Hand RivalLast { get; private set; }

        /// <summary>
        /// 上一局我方是赢是输
        /// </summary>
        protected Result MyLastResult { get; private set; }

        /// <summary>
        /// 上一局对方是赢是输
        /// </summary>
        protected Result RivalLastResult { get; private set; }

        /// <summary>
        /// 平台调用的总入口
        /// </summary>
        /// <param name="RivalLast"></param>
        /// <returns></returns>
        public Hand GetNext(Hand RivalLast)
        {
            this.RivalLast = RivalLast;

            if (RivalLast == Hand.Zero)
            {
                MyLast = Think();
                MyLast = Hand.石头;
                return MyLast;
            }

            if (MyLast > RivalLast)
            {
                MyLastResult = Result.Win;
                RivalLastResult = Result.Lost;
            }
            else if (MyLast < RivalLast)
            {
                MyLastResult = Result.Lost;
                RivalLastResult = Result.Win;
            }
            else
            {
                MyLastResult = Result.Same;
                RivalLastResult = Result.Same;
            }
            MyLast = Think();
            return MyLast;
        }

        protected abstract Hand Think();

        /// <summary>
        /// 选手别名
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return this.GetType().Name;
        }
    }

    /// <summary>
    /// 结果
    /// </summary>
    public enum Result
    {
        None = 0,
        Win,
        Same,
        Lost,
    }
}
