﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace RowShamBowUI
{
    /// <summary>
    /// 产生循环赛选手的编号对，一对包含两个编号，编号从0开始
    /// </summary>
    class RoundPair
    {
        int playerCount;        //选手数量
        public RoundPair(int playerCount)
        {
            this.playerCount = playerCount;
        }

        int i = 0, j = 0;
        /// <summary>
        /// 由内Start2改编而来的外循环，功能等效于Start2
        /// </summary>
        /// <param name="upIndex"></param>
        /// <param name="downIndex"></param>
        /// <returns></returns>
        public bool GetNext(out int upIndex, out int downIndex)
        {
            while (true)
            {
                if (j < playerCount)
                {
                    int up = (i + j) % playerCount;
                    int down = (playerCount - j) % playerCount;
                    j++;
                    if (up < down)
                    {
                        upIndex = up;
                        downIndex = down;
                        return true;
                    }
                }
                else
                {
                    i++;
                    if (i >= playerCount)
                    {
                        i = j = 0;
                        upIndex = downIndex = -1;
                        return false;
                    }
                    j = 0;
                }
            }
        }

        internal void Test()
        {
            int x, y;
            Start2();
            Console.WriteLine();
            while (GetNext(out x, out y))
            {
                Console.Write("{0}_{1} ", x, y);
            }
        }
        /// <summary>
        /// 内循环的方式，用于对GetNext方法进行校验
        /// </summary>
        private void Start2()
        {
            for (int i = 0; i < playerCount; i++)
            {
                for (int j = 0; j < playerCount; j++)
                {
                    int up = (i + j) % playerCount;
                    int down = (playerCount - j) % playerCount;
                    if (up < down)
                        Console.Write("{0}_{1} ", up, down);
                }
                Console.WriteLine();
            }
        }
    }
}
